Subject: Re: [ofa-general] NetEffect, iw_nes and kernel warning

From: Stephen Hemminger <[email-masked]>
Date: Wed, 28 Jan 2009 11:05:14 -0800

On Wed, 28 Jan 2009 10:05:29 -0800
Roland Dreier <[email-masked]> wrote:

>  > > but actually I still don't see how it's safe for a net driver to
>  > > call skb_linearize() from its transmit routine, since there's a
>  > > chance that that will unconditionally enable BHs?
>  > 
>  > It's simply not allowed.
>  > 
>  > dev_queue_xmit() at a higher level can do __skb_linearize()
>  > because it does so before doing the rcu_read_lock_bh().
> 
> OK, thanks... what confused me is that several other drivers also do
> skb_linearize() in their hard_start_xmit method... eg bnx2x,
> via-velocity, mv643xx_eth.  So there are several other lurking bugs to
> deal with here I guess.
> 
>  - R.

They all look like lurking (and untested) bug paths. mv643xx is especially
bad since it can leak skb. But it should be possible to call pull_tail
if bh is disabled (as long as irqs are enabled).